Index: trunk/include/iprt/cpp/list.h
===================================================================
--- trunk/include/iprt/cpp/list.h	(revision 36529)
+++ trunk/include/iprt/cpp/list.h	(revision 36532)
@@ -33,7 +33,4 @@
 #include <new> /* For std::bad_alloc */
 
-namespace iprt
-{
-
 /** @defgroup grp_rt_cpp_list   C++ List support
  * @ingroup grp_rt_cpp
@@ -58,11 +55,11 @@
  *
  * The size of the internal array will usually not shrink, but grow
- * automatically. Only certain methods, like list::clear or the "=" operator
- * will reset any previously allocated memory. You can call list::setCapacity
- * for manual adjustment. If the size of an new list will be known, calling the
- * constructor with the necessary capacity will speed up the insertion of the
- * new items.
- *
- * For the full public interface these list classes offer see ListBase.
+ * automatically. Only certain methods, like RTCList::clear or the "=" operator
+ * will reset any previously allocated memory. You can call
+ * RTCList::setCapacity for manual adjustment. If the size of an new list will
+ * be known, calling the constructor with the necessary capacity will speed up
+ * the insertion of the new items.
+ *
+ * For the full public interface these list classes offer see RTCListBase.
  *
  * There are some requirements for the types used which follow:
@@ -90,5 +87,5 @@
  * changed when using the value as reference returned by this operator.
  *
- * The list class is reentrant. For a thread-safe variant see mtlist.
+ * The list class is reentrant. For a thread-safe variant see RTCMTList.
  *
  * Implementation details:
@@ -99,6 +96,6 @@
  *
  * Current specialized implementations:
- * - int64_t: iprt::list<int64_t>
- * - uint64_t: iprt::list<uint64_t>
+ * - int64_t: RTCList<int64_t>
+ * - uint64_t: RTCList<uint64_t>
  *
  * @{
@@ -109,5 +106,5 @@
  */
 template <bool G>
-class ListGuard;
+class RTCListGuard;
 
 /**
@@ -115,5 +112,5 @@
  */
 template <>
-class ListGuard<false>
+class RTCListGuard<false>
 {
 public:
@@ -125,8 +122,8 @@
 
 /**
- * General helper template for managing native values in ListBase.
+ * General helper template for managing native values in RTCListBase.
  */
 template <typename T1, typename T2>
-class ListHelper
+class RTCListHelper
 {
 public:
@@ -143,8 +140,8 @@
 
 /**
- * Specialized helper template for managing pointer values in ListBase.
+ * Specialized helper template for managing pointer values in RTCListBase.
  */
 template <typename T1>
-class ListHelper<T1, T1*>
+class RTCListHelper<T1, T1*>
 {
 public:
@@ -170,5 +167,5 @@
  */
 template <class T, typename ITYPE, bool MT>
-class ListBase
+class RTCListBase
 {
     /**
@@ -177,6 +174,6 @@
      * value.
      */
-    typedef typename if_ptr<ITYPE, T&, T>::result GET_RTYPE;
-    typedef typename if_ptr<ITYPE, const T&, const T>::result GET_CRTYPE;
+    typedef typename RTCIfPtr<ITYPE, T&, T>::result GET_RTYPE;
+    typedef typename RTCIfPtr<ITYPE, const T&, const T>::result GET_CRTYPE;
 
 public:
@@ -189,5 +186,5 @@
      * @throws  std::bad_alloc
      */
-    ListBase(size_t cCapacity = DefaultCapacity)
+    RTCListBase(size_t cCapacity = DefaultCapacity)
       : m_pArray(0)
       , m_cSize(0)
@@ -206,5 +203,5 @@
      * @throws  std::bad_alloc
      */
-    ListBase(const ListBase<T, ITYPE, MT>& other)
+    RTCListBase(const RTCListBase<T, ITYPE, MT>& other)
       : m_pArray(0)
       , m_cSize(0)
@@ -212,5 +209,5 @@
     {
         realloc_grow(other.m_cSize);
-        ListHelper<T, ITYPE>::copyTo(m_pArray, other.m_pArray, 0, other.m_cSize);
+        RTCListHelper<T, ITYPE>::copyTo(m_pArray, other.m_pArray, 0, other.m_cSize);
         m_cSize = other.m_cSize;
     }
@@ -219,7 +216,7 @@
      * Destructor.
      */
-    ~ListBase()
-    {
-        ListHelper<T, ITYPE>::eraseRange(m_pArray, 0, m_cSize);
+    ~RTCListBase()
+    {
+        RTCListHelper<T, ITYPE>::eraseRange(m_pArray, 0, m_cSize);
         if (m_pArray)
             RTMemFree(m_pArray);
@@ -273,5 +270,5 @@
      * @throws  std::bad_alloc
      */
-    ListBase<T, ITYPE, MT> &insert(size_t i, const T &val)
+    RTCListBase<T, ITYPE, MT> &insert(size_t i, const T &val)
     {
         m_guard.enterWrite();
@@ -279,5 +276,5 @@
             realloc_grow(m_cCapacity + DefaultCapacity);
         memmove(&m_pArray[i + 1], &m_pArray[i], (m_cSize - i) * sizeof(ITYPE));
-        ListHelper<T, ITYPE>::set(m_pArray, i, val);
+        RTCListHelper<T, ITYPE>::set(m_pArray, i, val);
         ++m_cSize;
         m_guard.leaveWrite();
@@ -293,5 +290,5 @@
      * @throws  std::bad_alloc
      */
-    ListBase<T, ITYPE, MT> &prepend(const T &val)
+    RTCListBase<T, ITYPE, MT> &prepend(const T &val)
     {
         return insert(0, val);
@@ -305,5 +302,5 @@
      * @throws  std::bad_alloc
      */
-    ListBase<T, ITYPE, MT> &prepend(const ListBase<T, ITYPE, MT> &other)
+    RTCListBase<T, ITYPE, MT> &prepend(const RTCListBase<T, ITYPE, MT> &other)
     {
         m_guard.enterWrite();
@@ -311,5 +308,5 @@
             realloc_grow(m_cCapacity + (other.m_cSize - (m_cCapacity - m_cSize)));
         memmove(&m_pArray[other.m_cSize], &m_pArray[0], m_cSize * sizeof(ITYPE));
-        ListHelper<T, ITYPE>::copyTo(m_pArray, other.m_pArray, 0, other.m_cSize);
+        RTCListHelper<T, ITYPE>::copyTo(m_pArray, other.m_pArray, 0, other.m_cSize);
         m_cSize += other.m_cSize;
         m_guard.leaveWrite();
@@ -325,10 +322,10 @@
      * @throws  std::bad_alloc
      */
-    ListBase<T, ITYPE, MT> &append(const T &val)
+    RTCListBase<T, ITYPE, MT> &append(const T &val)
     {
         m_guard.enterWrite();
         if (m_cSize == m_cCapacity)
             realloc_grow(m_cCapacity + DefaultCapacity);
-        ListHelper<T, ITYPE>::set(m_pArray, m_cSize, val);
+        RTCListHelper<T, ITYPE>::set(m_pArray, m_cSize, val);
         ++m_cSize;
         m_guard.leaveWrite();
@@ -344,10 +341,10 @@
      * @throws  std::bad_alloc
      */
-    ListBase<T, ITYPE, MT> &append(const ListBase<T, ITYPE, MT> &other)
+    RTCListBase<T, ITYPE, MT> &append(const RTCListBase<T, ITYPE, MT> &other)
     {
         m_guard.enterWrite();
         if (m_cCapacity - m_cSize < other.m_cSize)
             realloc_grow(m_cCapacity + (other.m_cSize - (m_cCapacity - m_cSize)));
-        ListHelper<T, ITYPE>::copyTo(m_pArray, other.m_pArray, m_cSize, other.m_cSize);
+        RTCListHelper<T, ITYPE>::copyTo(m_pArray, other.m_pArray, m_cSize, other.m_cSize);
         m_cSize += other.m_cSize;
         m_guard.leaveWrite();
@@ -363,5 +360,5 @@
      * @return  a reference to this list.
      */
-    ListBase<T, ITYPE, MT> &operator=(const ListBase<T, ITYPE, MT>& other)
+    RTCListBase<T, ITYPE, MT> &operator=(const RTCListBase<T, ITYPE, MT>& other)
     {
         /* Prevent self assignment */
@@ -371,5 +368,5 @@
         m_guard.enterWrite();
         /* Values cleanup */
-        ListHelper<T, ITYPE>::eraseRange(m_pArray, 0, m_cSize);
+        RTCListHelper<T, ITYPE>::eraseRange(m_pArray, 0, m_cSize);
 
         /* Copy */
@@ -377,5 +374,5 @@
             realloc_grow(other.m_cSize);
         m_cSize = other.m_cSize;
-        ListHelper<T, ITYPE>::copyTo(m_pArray, other.m_pArray, 0, other.m_cSize);
+        RTCListHelper<T, ITYPE>::copyTo(m_pArray, other.m_pArray, 0, other.m_cSize);
         m_guard.leaveWrite();
 
@@ -387,5 +384,5 @@
      *
      * @note No boundary checks are done. Make sure @a i is equal or greater zero
-     *       and smaller than list::size.
+     *       and smaller than RTCList::size.
      *
      * @param   i     The position of the item to replace.
@@ -393,9 +390,9 @@
      * @return  a reference to this list.
      */
-    ListBase<T, ITYPE, MT> &replace(size_t i, const T &val)
-    {
-        m_guard.enterWrite();
-        ListHelper<T, ITYPE>::erase(m_pArray, i);
-        ListHelper<T, ITYPE>::set(m_pArray, i, val);
+    RTCListBase<T, ITYPE, MT> &replace(size_t i, const T &val)
+    {
+        m_guard.enterWrite();
+        RTCListHelper<T, ITYPE>::erase(m_pArray, i);
+        RTCListHelper<T, ITYPE>::set(m_pArray, i, val);
         m_guard.leaveWrite();
 
@@ -407,5 +404,5 @@
      *
      * @note No boundary checks are done. Make sure @a i is equal or greater zero
-     *       and smaller than list::size.
+     *       and smaller than RTCList::size.
      *
      * @return   The first item.
@@ -414,5 +411,5 @@
     {
         m_guard.enterRead();
-        GET_CRTYPE res = ListHelper<T, ITYPE>::at(m_pArray, 0);
+        GET_CRTYPE res = RTCListHelper<T, ITYPE>::at(m_pArray, 0);
         m_guard.leaveRead();
         return res;
@@ -423,5 +420,5 @@
      *
      * @note No boundary checks are done. Make sure @a i is equal or greater zero
-     *       and smaller than list::size.
+     *       and smaller than RTCList::size.
      *
      * @return   The first item.
@@ -430,5 +427,5 @@
     {
         m_guard.enterRead();
-        GET_RTYPE res = ListHelper<T, ITYPE>::at(m_pArray, 0);
+        GET_RTYPE res = RTCListHelper<T, ITYPE>::at(m_pArray, 0);
         m_guard.leaveRead();
         return res;
@@ -439,5 +436,5 @@
      *
      * @note No boundary checks are done. Make sure @a i is equal or greater zero
-     *       and smaller than list::size.
+     *       and smaller than RTCList::size.
      *
      * @return   The last item.
@@ -446,5 +443,5 @@
     {
         m_guard.enterRead();
-        GET_CRTYPE res = ListHelper<T, ITYPE>::at(m_pArray, m_cSize - 1);
+        GET_CRTYPE res = RTCListHelper<T, ITYPE>::at(m_pArray, m_cSize - 1);
         m_guard.leaveRead();
         return res;
@@ -455,5 +452,5 @@
      *
      * @note No boundary checks are done. Make sure @a i is equal or greater zero
-     *       and smaller than list::size.
+     *       and smaller than RTCList::size.
      *
      * @return   The last item.
@@ -462,5 +459,5 @@
     {
         m_guard.enterRead();
-        GET_RTYPE res = ListHelper<T, ITYPE>::at(m_pArray, m_cSize - 1);
+        GET_RTYPE res = RTCListHelper<T, ITYPE>::at(m_pArray, m_cSize - 1);
         m_guard.leaveRead();
         return res;
@@ -471,5 +468,5 @@
      *
      * @note No boundary checks are done. Make sure @a i is equal or greater zero
-     *       and smaller than list::size.
+     *       and smaller than RTCList::size.
      *
      * @param   i     The position of the item to return.
@@ -479,5 +476,5 @@
     {
         m_guard.enterRead();
-        GET_CRTYPE res = ListHelper<T, ITYPE>::at(m_pArray, i);
+        GET_CRTYPE res = RTCListHelper<T, ITYPE>::at(m_pArray, i);
         m_guard.leaveRead();
         return res;
@@ -488,5 +485,5 @@
      *
      * @note No boundary checks are done. Make sure @a i is equal or greater zero
-     *       and smaller than list::size.
+     *       and smaller than RTCList::size.
      *
      * @param   i     The position of the item to return.
@@ -496,5 +493,5 @@
     {
         m_guard.enterRead();
-        GET_RTYPE res = ListHelper<T, ITYPE>::at(m_pArray, i);
+        GET_RTYPE res = RTCListHelper<T, ITYPE>::at(m_pArray, i);
         m_guard.leaveRead();
         return res;
@@ -505,5 +502,5 @@
      *
      * @note No boundary checks are done. Make sure @a i is equal or greater zero
-     *       and smaller than list::size.
+     *       and smaller than RTCList::size.
      *
      * @param   i     The position of the item to return.
@@ -513,5 +510,5 @@
     {
         m_guard.enterRead();
-        T &res = ListHelper<T, ITYPE>::at(m_pArray, i);
+        T &res = RTCListHelper<T, ITYPE>::at(m_pArray, i);
         m_guard.leaveRead();
         return res;
@@ -533,5 +530,5 @@
             return T();
         }
-        T res = ListHelper<T, ITYPE>::at(m_pArray, i);
+        T res = RTCListHelper<T, ITYPE>::at(m_pArray, i);
         m_guard.leaveRead();
         return res;
@@ -554,5 +551,5 @@
             return defaultVal;
         }
-        T res = ListHelper<T, ITYPE>::at(m_pArray, i);
+        T res = RTCListHelper<T, ITYPE>::at(m_pArray, i);
         m_guard.leaveRead();
         return res;
@@ -563,5 +560,5 @@
      *
      * @note No boundary checks are done. Make sure @a i is equal or greater zero
-     *       and smaller than list::size.
+     *       and smaller than RTCList::size.
      *
      * @param   i   The position of the item to remove.
@@ -570,5 +567,5 @@
     {
         m_guard.enterWrite();
-        ListHelper<T, ITYPE>::erase(m_pArray, i);
+        RTCListHelper<T, ITYPE>::erase(m_pArray, i);
         /* Not last element? */
         if (i < m_cSize - 1)
@@ -582,6 +579,6 @@
      *
      * @note No boundary checks are done. Make sure @a iFrom is equal or
-     *       greater zero and smaller than list::size. @a iTo has to be
-     *       greater than @a iFrom and equal or smaller than list::size.
+     *       greater zero and smaller than RTCList::size. @a iTo has to be
+     *       greater than @a iFrom and equal or smaller than RTCList::size.
      *
      * @param   iFrom   The start position of the items to remove.
@@ -591,5 +588,5 @@
     {
         m_guard.enterWrite();
-        ListHelper<T, ITYPE>::eraseRange(m_pArray, iFrom, iTo - iFrom);
+        RTCListHelper<T, ITYPE>::eraseRange(m_pArray, iFrom, iTo - iFrom);
         /* Not last elements? */
         if (m_cSize - iTo > 0)
@@ -606,5 +603,5 @@
         m_guard.enterWrite();
         /* Values cleanup */
-        ListHelper<T, ITYPE>::eraseRange(m_pArray, 0, m_cSize);
+        RTCListHelper<T, ITYPE>::eraseRange(m_pArray, 0, m_cSize);
         if (m_cSize != DefaultCapacity)
             realloc_grow(DefaultCapacity);
@@ -633,5 +630,5 @@
             && m_pArray)
         {
-            ListHelper<T, ITYPE>::eraseRange(m_pArray, cNewSize, m_cSize - cNewSize);
+            RTCListHelper<T, ITYPE>::eraseRange(m_pArray, cNewSize, m_cSize - cNewSize);
             m_cSize -= m_cSize - cNewSize;
         }
@@ -690,17 +687,17 @@
     size_t m_cCapacity;
     /** The guard used to serialize the access to the items. */
-    ListGuard<MT> m_guard;
+    RTCListGuard<MT> m_guard;
 };
 
 template <class T, typename ITYPE, bool MT>
-const size_t ListBase<T, ITYPE, MT>::DefaultCapacity = 10;
+const size_t RTCListBase<T, ITYPE, MT>::DefaultCapacity = 10;
 
 /**
  * Template class which automatically determines the type of list to use.
  *
- * @see ListBase
- */
-template <class T, typename ITYPE = typename if_<(sizeof(T) > sizeof(void*)), T*, T>::result>
-class list : public ListBase<T, ITYPE, false> {};
+ * @see RTCListBase
+ */
+template <class T, typename ITYPE = typename RTCIf<(sizeof(T) > sizeof(void*)), T*, T>::result>
+class RTCList : public RTCListBase<T, ITYPE, false> {};
 
 /**
@@ -708,8 +705,8 @@
  * values even on a 32-bit host.
  *
- * @see ListBase
+ * @see RTCListBase
  */
 template <>
-class list<uint64_t>: public ListBase<uint64_t, uint64_t, false> {};
+class RTCList<uint64_t>: public RTCListBase<uint64_t, uint64_t, false> {};
 
 /**
@@ -717,13 +714,11 @@
  * values even on a 32-bit host.
  *
- * @see ListBase
+ * @see RTCListBase
  */
 template <>
-class list<int64_t>: public ListBase<int64_t, int64_t, false> {};
+class RTCList<int64_t>: public RTCListBase<int64_t, int64_t, false> {};
 
 /** @} */
 
-} /* namespace iprt */
-
 #endif /* !___iprt_cpp_list_h */
 
Index: trunk/include/iprt/cpp/meta.h
===================================================================
--- trunk/include/iprt/cpp/meta.h	(revision 36529)
+++ trunk/include/iprt/cpp/meta.h	(revision 36532)
@@ -27,7 +27,4 @@
 #define ___iprt_cpp_meta_h
 
-namespace iprt
-{
-
 /** @defgroup grp_rt_cpp_meta   C++ Meta programming utilities
  * @ingroup grp_rt_cpp
@@ -44,5 +41,5 @@
  */
 template <bool Condition, typename TrueResult, typename FalseResult>
-struct if_;
+struct RTCIf;
 
 /**
@@ -53,5 +50,5 @@
  */
 template <typename TrueResult, typename FalseResult>
-struct if_<true, TrueResult, FalseResult>
+struct RTCIf<true, TrueResult, FalseResult>
 {
     typedef TrueResult result;
@@ -65,5 +62,5 @@
  */
 template <typename TrueResult, typename FalseResult>
-struct if_<false, TrueResult, FalseResult>
+struct RTCIf<false, TrueResult, FalseResult>
 {
     typedef FalseResult result;
@@ -81,5 +78,5 @@
  */
 template <class T, typename TrueResult, typename FalseResult>
-struct if_ptr
+struct RTCIfPtr
 {
     typedef FalseResult result;
@@ -97,5 +94,5 @@
  */
 template <class T, typename TrueResult, typename FalseResult>
-struct if_ptr<T*, TrueResult, FalseResult>
+struct RTCIfPtr<T*, TrueResult, FalseResult>
 {
     typedef TrueResult result;
@@ -104,6 +101,4 @@
 /** @} */
 
-} /* namespace iprt */
-
 #endif /* !___iprt_cpp_meta_h */
 
Index: trunk/include/iprt/cpp/ministring.h
===================================================================
--- trunk/include/iprt/cpp/ministring.h	(revision 36529)
+++ trunk/include/iprt/cpp/ministring.h	(revision 36532)
@@ -825,6 +825,6 @@
      * @returns separated strings as string list.
      */
-    iprt::list<RTCString, RTCString *> split(const RTCString &a_rstrSep,
-                                             SplitMode a_enmMode = RemoveEmptyParts);
+    RTCList<RTCString, RTCString *> split(const RTCString &a_rstrSep,
+                                          SplitMode a_enmMode = RemoveEmptyParts);
 
     /**
@@ -835,5 +835,5 @@
      * @returns joined string.
      */
-    static RTCString join(const iprt::list<RTCString, RTCString *> &a_rList,
+    static RTCString join(const RTCList<RTCString, RTCString *> &a_rList,
                           const RTCString &a_rstrSep = "");
 
Index: trunk/include/iprt/cpp/mtlist.h
===================================================================
--- trunk/include/iprt/cpp/mtlist.h	(revision 36529)
+++ trunk/include/iprt/cpp/mtlist.h	(revision 36532)
@@ -31,7 +31,4 @@
 #include <iprt/semaphore.h>
 
-namespace iprt
-{
-
 /** @addtogroup grp_rt_cpp_list
  * @{
@@ -42,9 +39,9 @@
  */
 template <>
-class ListGuard<true>
+class RTCListGuard<true>
 {
 public:
-    ListGuard() { int rc = RTSemRWCreate(&m_hRWSem); AssertRC(rc); }
-    ~ListGuard() { RTSemRWDestroy(m_hRWSem); }
+    RTCListGuard() { int rc = RTSemRWCreate(&m_hRWSem); AssertRC(rc); }
+    ~RTCListGuard() { RTSemRWDestroy(m_hRWSem); }
     inline void enterRead() const { int rc = RTSemRWRequestRead(m_hRWSem, RT_INDEFINITE_WAIT); AssertRC(rc); }
     inline void leaveRead() const { int rc = RTSemRWReleaseRead(m_hRWSem); AssertRC(rc); }
@@ -59,5 +56,5 @@
  * @brief Generic thread-safe list class.
  *
- * mtlist is a thread-safe implementation of the list class. It uses a
+ * RTCMTList is a thread-safe implementation of the list class. It uses a
  * read/write semaphore to serialize the access to the items. Several readers
  * can simultaneous access different or the same item. If one thread is writing
@@ -70,8 +67,8 @@
  * implementation.
  *
- * @see ListBase
+ * @see RTCListBase
  */
-template <class T, typename ITYPE = typename if_<(sizeof(T) > sizeof(void*)), T*, T>::result>
-class mtlist : public ListBase<T, ITYPE, true> {};
+template <class T, typename ITYPE = typename RTCIf<(sizeof(T) > sizeof(void*)), T*, T>::result>
+class RTCMTList : public RTCListBase<T, ITYPE, true> {};
 
 /**
@@ -79,8 +76,8 @@
  * unsigned 64-bit values even on a 32-bit host.
  *
- * @see ListBase
+ * @see RTCListBase
  */
 template <>
-class mtlist<uint64_t>: public ListBase<uint64_t, uint64_t, true> {};
+class RTCMTList<uint64_t>: public RTCListBase<uint64_t, uint64_t, true> {};
 
 /**
@@ -88,13 +85,11 @@
  * signed 64-bit values even on a 32-bit host.
  *
- * @see ListBase
+ * @see RTCListBase
  */
 template <>
-class mtlist<int64_t>: public ListBase<int64_t, uint64_t, true> {};
+class RTCMTList<int64_t>: public RTCListBase<int64_t, uint64_t, true> {};
 
 /** @} */
 
-} /* namespace iprt */
-
 #endif /* !___iprt_cpp_mtlist_h */
 