Index: trunk/include/iprt/mangling.h
===================================================================
--- trunk/include/iprt/mangling.h	(revision 36545)
+++ trunk/include/iprt/mangling.h	(revision 36546)
@@ -526,4 +526,5 @@
 # define RTLdrLoad                                      RT_MANGLER(RTLdrLoad)
 # define RTLdrLoadAppPriv                               RT_MANGLER(RTLdrLoadAppPriv)
+# define RTLdrLoadEx                                    RT_MANGLER(RTLdrLoadEx)
 # define RTLdrOpen                                      RT_MANGLER(RTLdrOpen)
 # define RTLdrOpenkLdr                                  RT_MANGLER(RTLdrOpenkLdr)
@@ -656,4 +657,5 @@
 # define RTManifestEntryAddIoStream                     RT_MANGLER(RTManifestEntryAddIoStream)
 # define RTManifestEntryAddPassthruIoStream             RT_MANGLER(RTManifestEntryAddPassthruIoStream)
+# define RTManifestEntryExists                          RT_MANGLER(RTManifestEntryExists)
 # define RTManifestEntryRemove                          RT_MANGLER(RTManifestEntryRemove)
 # define RTManifestEntrySetAttr                         RT_MANGLER(RTManifestEntrySetAttr)
@@ -692,4 +694,5 @@
 # define RTMemContAlloc                                 RT_MANGLER(RTMemContAlloc) /* r0drv */
 # define RTMemContFree                                  RT_MANGLER(RTMemContFree) /* r0drv */
+# define RTMemDump                                      RT_MANGLER(RTMemDump)
 # define RTMemDupExTag                                  RT_MANGLER(RTMemDupExTag)
 # define RTMemDupTag                                    RT_MANGLER(RTMemDupTag)
@@ -805,4 +808,5 @@
 # define RTPathAppendEx                                 RT_MANGLER(RTPathAppendEx)
 # define RTPathAppPrivateArch                           RT_MANGLER(RTPathAppPrivateArch)
+# define RTPathAppPrivateArchTop                        RT_MANGLER(RTPathAppPrivateArchTop)
 # define RTPathAppPrivateNoArch                         RT_MANGLER(RTPathAppPrivateNoArch)
 # define RTPathChangeToDosSlashes                       RT_MANGLER(RTPathChangeToDosSlashes)
@@ -1139,7 +1143,14 @@
 # define RTStrFormat                                    RT_MANGLER(RTStrFormat)
 # define RTStrFormatNumber                              RT_MANGLER(RTStrFormatNumber)
+# define RTStrFormatR80                                 RT_MANGLER(RTStrFormatR80)
+# define RTStrFormatR80u2                               RT_MANGLER(RTStrFormatR80u2)
 # define RTStrFormatTypeDeregister                      RT_MANGLER(RTStrFormatTypeDeregister)
 # define RTStrFormatTypeRegister                        RT_MANGLER(RTStrFormatTypeRegister)
 # define RTStrFormatTypeSetUser                         RT_MANGLER(RTStrFormatTypeSetUser)
+# define RTStrFormatU128                                RT_MANGLER(RTStrFormatU128)
+# define RTStrFormatU16                                 RT_MANGLER(RTStrFormatU16)
+# define RTStrFormatU32                                 RT_MANGLER(RTStrFormatU32)
+# define RTStrFormatU64                                 RT_MANGLER(RTStrFormatU64)
+# define RTStrFormatU8                                  RT_MANGLER(RTStrFormatU8)
 # define RTStrFormatV                                   RT_MANGLER(RTStrFormatV)
 # define RTStrFree                                      RT_MANGLER(RTStrFree)
@@ -1185,4 +1196,5 @@
 # define RTStrSpaceEnumerate                            RT_MANGLER(RTStrSpaceEnumerate)
 # define RTStrSpaceGet                                  RT_MANGLER(RTStrSpaceGet)
+# define RTStrSpaceGetN                                 RT_MANGLER(RTStrSpaceGetN)
 # define RTStrSpaceInsert                               RT_MANGLER(RTStrSpaceInsert)
 # define RTStrSpaceRemove                               RT_MANGLER(RTStrSpaceRemove)
@@ -1474,10 +1486,16 @@
 # define RTVfsDirRelease                                RT_MANGLER(RTVfsDirRelease)
 # define RTVfsDirRetain                                 RT_MANGLER(RTVfsDirRetain)
+# define RTVfsFileFlush                                 RT_MANGLER(RTVfsFileFlush)
 # define RTVfsFileFromRTFile                            RT_MANGLER(RTVfsFileFromRTFile)
 # define RTVfsFileOpen                                  RT_MANGLER(RTVfsFileOpen)
+# define RTVfsFilePoll                                  RT_MANGLER(RTVfsFilePoll)
+# define RTVfsFileQueryInfo                             RT_MANGLER(RTVfsFileQueryInfo)
+# define RTVfsFileRead                                  RT_MANGLER(RTVfsFileRead)
 # define RTVfsFileRelease                               RT_MANGLER(RTVfsFileRelease)
 # define RTVfsFileRetain                                RT_MANGLER(RTVfsFileRetain)
 # define RTVfsFileSeek                                  RT_MANGLER(RTVfsFileSeek)
+# define RTVfsFileTell                                  RT_MANGLER(RTVfsFileTell)
 # define RTVfsFileToIoStream                            RT_MANGLER(RTVfsFileToIoStream)
+# define RTVfsFileWrite                                 RT_MANGLER(RTVfsFileWrite)
 # define RTVfsFsStrmNext                                RT_MANGLER(RTVfsFsStrmNext)
 # define RTVfsFsStrmQueryInfo                           RT_MANGLER(RTVfsFsStrmQueryInfo)
@@ -1499,4 +1517,5 @@
 # define RTVfsIoStrmTell                                RT_MANGLER(RTVfsIoStrmTell)
 # define RTVfsIoStrmToFile                              RT_MANGLER(RTVfsIoStrmToFile)
+# define RTVfsIoStrmValidateUtf8Encoding                RT_MANGLER(RTVfsIoStrmValidateUtf8Encoding)
 # define RTVfsIoStrmWrite                               RT_MANGLER(RTVfsIoStrmWrite)
 # define RTVfsIoStrmZeroFill                            RT_MANGLER(RTVfsIoStrmZeroFill)