Index: trunk/src/VBox/Runtime/include/internal/assert.h
===================================================================
--- trunk/src/VBox/Runtime/include/internal/assert.h	(revision 36549)
+++ trunk/src/VBox/Runtime/include/internal/assert.h	(revision 36555)
@@ -43,5 +43,5 @@
  * @param   pszFunction Location function name.
  */
-void rtR0AssertNativeMsg1(const char *pszExpr, unsigned uLine, const char *pszFile, const char *pszFunction);
+DECLHIDDEN(void) rtR0AssertNativeMsg1(const char *pszExpr, unsigned uLine, const char *pszFile, const char *pszFunction);
 
 /**
@@ -54,5 +54,5 @@
  * @param   va          Arguments to that string.
  */
-void rtR0AssertNativeMsg2V(bool fInitial, const char *pszFormat, va_list va);
+DECLHIDDEN(void) rtR0AssertNativeMsg2V(bool fInitial, const char *pszFormat, va_list va);
 
 #endif
Index: trunk/src/VBox/Runtime/include/internal/initterm.h
===================================================================
--- trunk/src/VBox/Runtime/include/internal/initterm.h	(revision 36549)
+++ trunk/src/VBox/Runtime/include/internal/initterm.h	(revision 36555)
@@ -39,10 +39,10 @@
  * @returns IPRT status code.
  */
-int rtR0InitNative(void);
+DECLHIDDEN(int)  rtR0InitNative(void);
 
 /**
  * Platform specific termination.
  */
-void rtR0TermNative(void);
+DECLHIDDEN(void) rtR0TermNative(void);
 
 #endif /* IN_RING0 */
Index: trunk/src/VBox/Runtime/include/internal/memobj.h
===================================================================
--- trunk/src/VBox/Runtime/include/internal/memobj.h	(revision 36549)
+++ trunk/src/VBox/Runtime/include/internal/memobj.h	(revision 36555)
@@ -1,3 +1,3 @@
-/* $Revision$ */
+/* $Id$ */
 /** @file
  * IPRT - Ring-0 Memory Objects.
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 Oracle Corporation
+ * Copyright (C) 2006-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -288,5 +288,5 @@
  * @param   pMem        The ring-0 memory object handle to the memory which should be freed.
  */
-int rtR0MemObjNativeFree(PRTR0MEMOBJINTERNAL pMem);
+DECLHIDDEN(int) rtR0MemObjNativeFree(PRTR0MEMOBJINTERNAL pMem);
 
 /**
@@ -300,5 +300,5 @@
  * @param   fExecutable     Flag indicating whether it should be permitted to executed code in the memory object.
  */
-int rtR0MemObjNativeAllocPage(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, bool fExecutable);
+DECLHIDDEN(int) rtR0MemObjNativeAllocPage(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, bool fExecutable);
 
 /**
@@ -312,5 +312,5 @@
  * @param   fExecutable     Flag indicating whether it should be permitted to executed code in the memory object.
  */
-int rtR0MemObjNativeAllocLow(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, bool fExecutable);
+DECLHIDDEN(int) rtR0MemObjNativeAllocLow(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, bool fExecutable);
 
 /**
@@ -324,5 +324,5 @@
  * @param   fExecutable     Flag indicating whether it should be permitted to executed code in the memory object.
  */
-int rtR0MemObjNativeAllocCont(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, bool fExecutable);
+DECLHIDDEN(int) rtR0MemObjNativeAllocCont(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, bool fExecutable);
 
 /**
@@ -337,5 +337,5 @@
  * @param   R0Process       The process to lock pages in.
  */
-int rtR0MemObjNativeLockUser(PPRTR0MEMOBJINTERNAL ppMem, RTR3PTR R3Ptr, size_t cb, uint32_t fAccess, RTR0PROCESS R0Process);
+DECLHIDDEN(int) rtR0MemObjNativeLockUser(PPRTR0MEMOBJINTERNAL ppMem, RTR3PTR R3Ptr, size_t cb, uint32_t fAccess, RTR0PROCESS R0Process);
 
 /**
@@ -349,5 +349,5 @@
  *                          and RTMEM_PROT_WRITE.
  */
-int rtR0MemObjNativeLockKernel(PPRTR0MEMOBJINTERNAL ppMem, void *pv, size_t cb, uint32_t fAccess);
+DECLHIDDEN(int) rtR0MemObjNativeLockKernel(PPRTR0MEMOBJINTERNAL ppMem, void *pv, size_t cb, uint32_t fAccess);
 
 /**
@@ -363,5 +363,5 @@
  *                          Supported values are PAGE_SIZE, _2M, _4M and _1G.
  */
-int rtR0MemObjNativeAllocPhys(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, RTHCPHYS PhysHighest, size_t uAlignment);
+DECLHIDDEN(int) rtR0MemObjNativeAllocPhys(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, RTHCPHYS PhysHighest, size_t uAlignment);
 
 /**
@@ -376,5 +376,5 @@
  *                          NIL_RTHCPHYS if any address is acceptable.
  */
-int rtR0MemObjNativeAllocPhysNC(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, RTHCPHYS PhysHighest);
+DECLHIDDEN(int) rtR0MemObjNativeAllocPhysNC(PPRTR0MEMOBJINTERNAL ppMem, size_t cb, RTHCPHYS PhysHighest);
 
 /**
@@ -387,5 +387,5 @@
  * @param   uCachePolicy    One of the RTMEM_CACHE_XXX modes.
  */
-int rtR0MemObjNativeEnterPhys(PPRTR0MEMOBJINTERNAL ppMem, RTHCPHYS Phys, size_t cb, uint32_t uCachePolicy);
+DECLHIDDEN(int) rtR0MemObjNativeEnterPhys(PPRTR0MEMOBJINTERNAL ppMem, RTHCPHYS Phys, size_t cb, uint32_t uCachePolicy);
 
 /**
@@ -399,5 +399,5 @@
  * @param   uAlignment      The alignment of the reserved memory; PAGE_SIZE, _2M or _4M.
  */
-int rtR0MemObjNativeReserveKernel(PPRTR0MEMOBJINTERNAL ppMem, void *pvFixed, size_t cb, size_t uAlignment);
+DECLHIDDEN(int) rtR0MemObjNativeReserveKernel(PPRTR0MEMOBJINTERNAL ppMem, void *pvFixed, size_t cb, size_t uAlignment);
 
 /**
@@ -411,5 +411,5 @@
  * @param   R0Process       The process to reserve the memory in.
  */
-int rtR0MemObjNativeReserveUser(PPRTR0MEMOBJINTERNAL ppMem, RTR3PTR R3PtrFixed, size_t cb, size_t uAlignment, RTR0PROCESS R0Process);
+DECLHIDDEN(int) rtR0MemObjNativeReserveUser(PPRTR0MEMOBJINTERNAL ppMem, RTR3PTR R3PtrFixed, size_t cb, size_t uAlignment, RTR0PROCESS R0Process);
 
 /**
@@ -431,6 +431,6 @@
  *                          page aligned.
  */
-int rtR0MemObjNativeMapKernel(PPRTR0MEMOBJINTERNAL ppMem, RTR0MEMOBJ pMemToMap, void *pvFixed, size_t uAlignment,
-                              unsigned fProt, size_t offSub, size_t cbSub);
+DECLHIDDEN(int) rtR0MemObjNativeMapKernel(PPRTR0MEMOBJINTERNAL ppMem, RTR0MEMOBJ pMemToMap, void *pvFixed, size_t uAlignment,
+                                          unsigned fProt, size_t offSub, size_t cbSub);
 
 /**
@@ -445,5 +445,5 @@
  * @param   R0Process       The process to map the memory into.
  */
-int rtR0MemObjNativeMapUser(PPRTR0MEMOBJINTERNAL ppMem, PRTR0MEMOBJINTERNAL pMemToMap, RTR3PTR R3PtrFixed, size_t uAlignment, unsigned fProt, RTR0PROCESS R0Process);
+DECLHIDDEN(int) rtR0MemObjNativeMapUser(PPRTR0MEMOBJINTERNAL ppMem, PRTR0MEMOBJINTERNAL pMemToMap, RTR3PTR R3PtrFixed, size_t uAlignment, unsigned fProt, RTR0PROCESS R0Process);
 
 /**
@@ -459,5 +459,5 @@
  * @param   fProt           Combination of RTMEM_PROT_* flags.
  */
-int rtR0MemObjNativeProtect(PRTR0MEMOBJINTERNAL pMem, size_t offSub, size_t cbSub, uint32_t fProt);
+DECLHIDDEN(int) rtR0MemObjNativeProtect(PRTR0MEMOBJINTERNAL pMem, size_t offSub, size_t cbSub, uint32_t fProt);
 
 /**
@@ -471,8 +471,8 @@
  * @param   iPage           The page number within the object (valid).
  */
-RTHCPHYS rtR0MemObjNativeGetPagePhysAddr(PRTR0MEMOBJINTERNAL pMem, size_t iPage);
-
-PRTR0MEMOBJINTERNAL rtR0MemObjNew(size_t cbSelf, RTR0MEMOBJTYPE enmType, void *pv, size_t cb);
-void rtR0MemObjDelete(PRTR0MEMOBJINTERNAL pMem);
+DECLHIDDEN(RTHCPHYS) rtR0MemObjNativeGetPagePhysAddr(PRTR0MEMOBJINTERNAL pMem, size_t iPage);
+
+DECLHIDDEN(PRTR0MEMOBJINTERNAL) rtR0MemObjNew(size_t cbSelf, RTR0MEMOBJTYPE enmType, void *pv, size_t cb);
+DECLHIDDEN(void) rtR0MemObjDelete(PRTR0MEMOBJINTERNAL pMem);
 
 /** @} */
Index: trunk/src/VBox/Runtime/include/internal/process.h
===================================================================
--- trunk/src/VBox/Runtime/include/internal/process.h	(revision 36549)
+++ trunk/src/VBox/Runtime/include/internal/process.h	(revision 36555)
@@ -50,5 +50,5 @@
  * @remark  Located in sched.
  */
-int rtProcNativeSetPriority(RTPROCPRIORITY enmPriority);
+DECLHIDDEN(int) rtProcNativeSetPriority(RTPROCPRIORITY enmPriority);
 
 /**
Index: trunk/src/VBox/Runtime/include/internal/rand.h
===================================================================
--- trunk/src/VBox/Runtime/include/internal/rand.h	(revision 36549)
+++ trunk/src/VBox/Runtime/include/internal/rand.h	(revision 36555)
@@ -159,30 +159,14 @@
 RT_C_DECLS_BEGIN
 
-/**
- * Initialize OS facilities for generating random bytes.
- */
-void rtRandLazyInitNative(void);
-
-/**
- * Generate random bytes using OS facilities.
- *
- * @returns VINF_SUCCESS on success, some error status code on failure.
- * @param   pv      Where to store the random bytes.
- * @param   cb      How many random bytes to store.
- */
-int rtRandGenBytesNative(void *pv, size_t cb);
-
-void rtRandGenBytesFallback(void *pv, size_t cb) RT_NO_THROW;
-
-DECLCALLBACK(void)      rtRandAdvSynthesizeBytesFromU32(PRTRANDINT pThis, uint8_t *pb, size_t cb);
-DECLCALLBACK(void)      rtRandAdvSynthesizeBytesFromU64(PRTRANDINT pThis, uint8_t *pb, size_t cb);
-DECLCALLBACK(uint32_t)  rtRandAdvSynthesizeU32FromBytes(PRTRANDINT pThis, uint32_t u32First, uint32_t u32Last);
-DECLCALLBACK(uint32_t)  rtRandAdvSynthesizeU32FromU64(PRTRANDINT pThis, uint32_t u32First, uint32_t u32Last);
-DECLCALLBACK(uint64_t)  rtRandAdvSynthesizeU64FromBytes(PRTRANDINT pThis, uint64_t u64First, uint64_t u64Last);
-DECLCALLBACK(uint64_t)  rtRandAdvSynthesizeU64FromU32(PRTRANDINT pThis, uint64_t u64First, uint64_t u64Last);
-DECLCALLBACK(int)       rtRandAdvStubSeed(PRTRANDINT pThis, uint64_t u64Seed);
-DECLCALLBACK(int)       rtRandAdvStubSaveState(PRTRANDINT pThis, char *pszState, size_t *pcbState);
-DECLCALLBACK(int)       rtRandAdvStubRestoreState(PRTRANDINT pThis, char const *pszState);
-DECLCALLBACK(int)       rtRandAdvDefaultDestroy(PRTRANDINT pThis);
+DECLHIDDEN(DECLCALLBACK(void))      rtRandAdvSynthesizeBytesFromU32(PRTRANDINT pThis, uint8_t *pb, size_t cb);
+DECLHIDDEN(DECLCALLBACK(void))      rtRandAdvSynthesizeBytesFromU64(PRTRANDINT pThis, uint8_t *pb, size_t cb);
+DECLHIDDEN(DECLCALLBACK(uint32_t))  rtRandAdvSynthesizeU32FromBytes(PRTRANDINT pThis, uint32_t u32First, uint32_t u32Last);
+DECLHIDDEN(DECLCALLBACK(uint32_t))  rtRandAdvSynthesizeU32FromU64(PRTRANDINT pThis, uint32_t u32First, uint32_t u32Last);
+DECLHIDDEN(DECLCALLBACK(uint64_t))  rtRandAdvSynthesizeU64FromBytes(PRTRANDINT pThis, uint64_t u64First, uint64_t u64Last);
+DECLHIDDEN(DECLCALLBACK(uint64_t))  rtRandAdvSynthesizeU64FromU32(PRTRANDINT pThis, uint64_t u64First, uint64_t u64Last);
+DECLHIDDEN(DECLCALLBACK(int))       rtRandAdvStubSeed(PRTRANDINT pThis, uint64_t u64Seed);
+DECLHIDDEN(DECLCALLBACK(int))       rtRandAdvStubSaveState(PRTRANDINT pThis, char *pszState, size_t *pcbState);
+DECLHIDDEN(DECLCALLBACK(int))       rtRandAdvStubRestoreState(PRTRANDINT pThis, char const *pszState);
+DECLHIDDEN(DECLCALLBACK(int))       rtRandAdvDefaultDestroy(PRTRANDINT pThis);
 
 RT_C_DECLS_END
Index: trunk/src/VBox/Runtime/include/internal/sched.h
===================================================================
--- trunk/src/VBox/Runtime/include/internal/sched.h	(revision 36549)
+++ trunk/src/VBox/Runtime/include/internal/sched.h	(revision 36555)
@@ -41,5 +41,5 @@
  * @param   enmType     The thread type to be assumed for the current thread.
  */
-int rtSchedNativeCalcDefaultPriority(RTTHREADTYPE enmType);
+DECLHIDDEN(int) rtSchedNativeCalcDefaultPriority(RTTHREADTYPE enmType);
 
 RT_C_DECLS_END
Index: trunk/src/VBox/Runtime/include/internal/string.h
===================================================================
--- trunk/src/VBox/Runtime/include/internal/string.h	(revision 36549)
+++ trunk/src/VBox/Runtime/include/internal/string.h	(revision 36555)
@@ -48,12 +48,12 @@
 #endif
 
-size_t rtstrFormatRt(PFNRTSTROUTPUT pfnOutput, void *pvArgOutput, const char **ppszFormat, va_list *pArgs,
-                     int cchWidth, int cchPrecision, unsigned fFlags, char chArgSize);
-size_t rtstrFormatType(PFNRTSTROUTPUT pfnOutput, void *pvArgOutput, const char **ppszFormat, va_list *pArgs,
-                       int cchWidth, int cchPrecision, unsigned fFlags, char chArgSize);
+DECLHIDDEN(size_t) rtstrFormatRt(PFNRTSTROUTPUT pfnOutput, void *pvArgOutput, const char **ppszFormat, va_list *pArgs,
+                                 int cchWidth, int cchPrecision, unsigned fFlags, char chArgSize);
+DECLHIDDEN(size_t) rtstrFormatType(PFNRTSTROUTPUT pfnOutput, void *pvArgOutput, const char **ppszFormat, va_list *pArgs,
+                                   int cchWidth, int cchPrecision, unsigned fFlags, char chArgSize);
 
 #ifdef RT_WITH_ICONV_CACHE
-void rtStrIconvCacheInit(struct RTTHREADINT *pThread);
-void rtStrIconvCacheDestroy(struct RTTHREADINT *pThread);
+DECLHIDDEN(void) rtStrIconvCacheInit(struct RTTHREADINT *pThread);
+DECLHIDDEN(void) rtStrIconvCacheDestroy(struct RTTHREADINT *pThread);
 #endif
 
@@ -75,9 +75,9 @@
 } RTSTRICONV;
 
-int rtStrConvert(const char *pchInput, size_t cchInput, const char *pszInputCS,
-                 char **ppszOutput, size_t cbOutput, const char *pszOutputCS,
-                 unsigned cFactor, RTSTRICONV enmCacheIdx);
-const char *rtStrGetLocaleCodeset(void);
-int rtUtf8Length(const char *psz, size_t cch, size_t *pcuc, size_t *pcchActual);
+DECLHIDDEN(int) rtStrConvert(const char *pchInput, size_t cchInput, const char *pszInputCS,
+                             char **ppszOutput, size_t cbOutput, const char *pszOutputCS,
+                             unsigned cFactor, RTSTRICONV enmCacheIdx);
+DECLHIDDEN(const char *) rtStrGetLocaleCodeset(void);
+DECLHIDDEN(int) rtUtf8Length(const char *psz, size_t cch, size_t *pcuc, size_t *pcchActual);
 
 RT_C_DECLS_END
Index: trunk/src/VBox/Runtime/include/internal/thread.h
===================================================================
--- trunk/src/VBox/Runtime/include/internal/thread.h	(revision 36549)
+++ trunk/src/VBox/Runtime/include/internal/thread.h	(revision 36555)
@@ -138,5 +138,5 @@
  * @returns iprt status code.
  */
-int rtThreadNativeInit(void);
+DECLHIDDEN(int) rtThreadNativeInit(void);
 
 /**
@@ -148,5 +148,5 @@
  * @param   pNativeThread   Where to store the native thread identifier.
  */
-int rtThreadNativeCreate(PRTTHREADINT pThreadInt, PRTNATIVETHREAD pNativeThread);
+DECLHIDDEN(int) rtThreadNativeCreate(PRTTHREADINT pThreadInt, PRTNATIVETHREAD pNativeThread);
 
 /**
@@ -156,5 +156,5 @@
  * @param   pThread     Pointer to the thread structure.
  */
-int rtThreadNativeAdopt(PRTTHREADINT pThread);
+DECLHIDDEN(int) rtThreadNativeAdopt(PRTTHREADINT pThread);
 
 /**
@@ -164,5 +164,5 @@
  * @param   pThread         The thread structure.
  */
-void rtThreadNativeDestroy(PRTTHREADINT pThread);
+DECLHIDDEN(void) rtThreadNativeDestroy(PRTTHREADINT pThread);
 
 /**
@@ -178,5 +178,5 @@
  * @remark  Located in sched.
  */
-int rtThreadNativeSetPriority(PRTTHREADINT pThread, RTTHREADTYPE enmType);
+DECLHIDDEN(int) rtThreadNativeSetPriority(PRTTHREADINT pThread, RTTHREADTYPE enmType);
 
 #ifdef IN_RING3
@@ -188,5 +188,5 @@
  * threads properly.
  */
-void rtThreadNativeDetach(void);
+DECLHIDDEN(void) rtThreadNativeDetach(void);
 # endif
 #endif /* !IN_RING0 */
@@ -194,21 +194,18 @@
 
 /* thread.cpp */
-int          rtThreadMain(PRTTHREADINT pThread, RTNATIVETHREAD NativeThread, const char *pszThreadName);
-void         rtThreadBlocking(PRTTHREADINT pThread, RTTHREADSTATE enmState, uint64_t u64Block,
-                              const char *pszFile, unsigned uLine, RTUINTPTR uId);
-void         rtThreadUnblocked(PRTTHREADINT pThread, RTTHREADSTATE enmCurState);
-uint32_t     rtThreadRelease(PRTTHREADINT pThread);
-void         rtThreadTerminate(PRTTHREADINT pThread, int rc);
-PRTTHREADINT rtThreadGetByNative(RTNATIVETHREAD NativeThread);
-PRTTHREADINT rtThreadGet(RTTHREAD Thread);
-int          rtThreadInit(void);
-void         rtThreadTerm(void);
-void         rtThreadInsert(PRTTHREADINT pThread, RTNATIVETHREAD NativeThread);
-#ifdef IN_RING3
-int          rtThreadDoSetProcPriority(RTPROCPRIORITY enmPriority);
+DECLHIDDEN(int)          rtThreadMain(PRTTHREADINT pThread, RTNATIVETHREAD NativeThread, const char *pszThreadName);
+DECLHIDDEN(uint32_t)     rtThreadRelease(PRTTHREADINT pThread);
+DECLHIDDEN(void)         rtThreadTerminate(PRTTHREADINT pThread, int rc);
+DECLHIDDEN(PRTTHREADINT) rtThreadGetByNative(RTNATIVETHREAD NativeThread);
+DECLHIDDEN(PRTTHREADINT) rtThreadGet(RTTHREAD Thread);
+DECLHIDDEN(int)          rtThreadInit(void);
+DECLHIDDEN(void)         rtThreadTerm(void);
+DECLHIDDEN(void)         rtThreadInsert(PRTTHREADINT pThread, RTNATIVETHREAD NativeThread);
+#ifdef IN_RING3
+DECLHIDDEN(int)          rtThreadDoSetProcPriority(RTPROCPRIORITY enmPriority);
 #endif /* !IN_RING0 */
 #ifdef IPRT_WITH_GENERIC_TLS
-void         rtThreadClearTlsEntry(RTTLS iTls);
-void         rtThreadTlsDestruction(PRTTHREADINT pThread); /* in tls-generic.cpp */
+DECLHIDDEN(void)         rtThreadClearTlsEntry(RTTLS iTls);
+DECLHIDDEN(void)         rtThreadTlsDestruction(PRTTHREADINT pThread); /* in tls-generic.cpp */
 #endif
 