Index: /trunk/include/iprt/dir.h
===================================================================
--- /trunk/include/iprt/dir.h	(revision 36576)
+++ /trunk/include/iprt/dir.h	(revision 36577)
@@ -90,4 +90,24 @@
  */
 RTDECL(int) RTDirCreateTemp(char *pszTemplate);
+
+/**
+ * Creates a new directory with a unique name by appending a number.
+ *
+ * First it is tried to create the directory without any numbers appended.
+ * When this fails a number string is appended (starting with 1) separated by
+ * the optional separator. The numbers are zero padded.
+ *
+ * On success @a pszPath contains the path created.
+ *
+ * @returns iprt status code.
+ * @param   pszPath     Path to the directory to create.
+ * @param   cbSize      The size of pszPath. Needs enough space for holding the
+ *                      digits and the optional separator.
+ * @param   fMode       The mode of the new directory.
+ * @param   cchDigits   How many digits should the number maximal have.
+ * @param   chSep       The separator used between the path and the number. Can
+ *                      be zero. (optional)
+ */
+RTDECL(int) RTDirCreateUniqueNumbered(char *pszPath, size_t cbSize, RTFMODE fMode, size_t cchDigits, char chSep);
 
 /**
Index: /trunk/src/VBox/Runtime/generic/RTDirCreateUniqueNumbered-generic.cpp
===================================================================
--- /trunk/src/VBox/Runtime/generic/RTDirCreateUniqueNumbered-generic.cpp	(revision 36577)
+++ /trunk/src/VBox/Runtime/generic/RTDirCreateUniqueNumbered-generic.cpp	(revision 36577)
@@ -0,0 +1,91 @@
+/* $Id$ */
+/** @file
+ * IPRT - RTDirCreateUniqueNumbered, generic implementation.
+ */
+
+/*
+ * Copyright (C) 2011 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ */
+
+
+/*******************************************************************************
+*   Header Files                                                               *
+*******************************************************************************/
+#include <iprt/dir.h>
+#include "internal/iprt.h"
+
+#include <iprt/assert.h>
+#include <iprt/err.h>
+#include <iprt/path.h>
+#include <iprt/string.h>
+
+RTDECL(int) RTDirCreateUniqueNumbered(char *pszPath, size_t cbSize, RTFMODE fMode, size_t cchDigits, char chSep)
+{
+    /*
+     * Validate input.
+     */
+    AssertPtrReturn(pszPath, VERR_INVALID_POINTER);
+    AssertReturn(cbSize, VERR_INVALID_PARAMETER);
+    AssertReturn(cchDigits, VERR_INVALID_PARAMETER);
+    /* Check for enough space. */
+    char *pszEnd = strchr(pszPath, '\0');
+    AssertReturn(cbSize - 1 - (pszEnd - pszPath) >= cchDigits + (chSep ? 1 : 0), VERR_BUFFER_OVERFLOW);
+
+    /* First try is to create the path without any numbers. */
+    int rc = RTDirCreate(pszPath, fMode);
+    if (   RT_SUCCESS(rc)
+        || rc != VERR_ALREADY_EXISTS)
+        return rc;
+
+    /* If the separator value isn't zero, add it. */
+    if (chSep != '\0')
+    {
+        *pszEnd++ = chSep;
+        *pszEnd   = '\0';
+    }
+
+    /* How many tries? */
+    size_t cMaxTries = 10;
+    for (size_t i = 0; i < cchDigits - 1; ++i)
+        cMaxTries *= 10;
+
+    /* Try cMaxTries - 1 counts to create a directory with the appended number. */
+    size_t i = 1;
+    while (i < cMaxTries)
+    {
+        /* Format the number with leading zero's. */
+        rc = RTStrFormatNumber(pszEnd, i, 10, cchDigits, 0, RTSTR_F_WIDTH | RTSTR_F_ZEROPAD);
+        if (RT_FAILURE(rc))
+        {
+            *pszPath = '\0';
+            return rc;
+        }
+        rc = RTDirCreate(pszPath, fMode);
+        if (RT_SUCCESS(rc))
+            return rc;
+        ++i;
+    }
+
+    /* We've given up. */
+    *pszPath = '\0';
+    return VERR_ALREADY_EXISTS;
+}
+RT_EXPORT_SYMBOL(RTDirCreateUniqueNumbered);
+
Index: /trunk/src/VBox/Runtime/testcase/tstRTDirCreateUniqueNumbered.cpp
===================================================================
--- /trunk/src/VBox/Runtime/testcase/tstRTDirCreateUniqueNumbered.cpp	(revision 36577)
+++ /trunk/src/VBox/Runtime/testcase/tstRTDirCreateUniqueNumbered.cpp	(revision 36577)
@@ -0,0 +1,129 @@
+/* $Id$ */
+/** @file
+ * IPRT Testcase - Unique directory creation.
+ */
+
+/*
+ * Copyright (C) 2011 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ */
+
+/*******************************************************************************
+*   Header Files                                                               *
+*******************************************************************************/
+#include <iprt/dir.h>
+
+#include <iprt/path.h>
+#include <iprt/mem.h>
+#include <iprt/string.h>
+#include <iprt/test.h>
+
+
+/*******************************************************************************
+*   Global Variables                                                           *
+*******************************************************************************/
+static char g_szTempPath[RTPATH_MAX - 50];
+
+
+static void tst1(size_t cTest, size_t cchDigits, char chSep)
+{
+    RTTestISubF("tst #%u (digits: %u; sep: %c)", cTest, cchDigits, chSep ? chSep : ' ');
+
+    /* We try to create max possible + one. */
+    size_t cTimes = 1;
+    for (size_t i = 0; i < cchDigits; ++i)
+        cTimes *= 10;
+
+    /* Allocate the result array. */
+    char **papszNames = (char **)RTMemTmpAllocZ(cTimes * sizeof(char *));
+    RTTESTI_CHECK_RETV(papszNames != NULL);
+
+    int rc;
+    /* The test loop. */
+    size_t i;
+    for (i = 0; i < cTimes; i++)
+    {
+        char szName[RTPATH_MAX];
+        RTTESTI_CHECK_RC(rc = RTPathAppend(strcpy(szName, g_szTempPath), sizeof(szName), "RTDirCreateUniqueNumbered"), VINF_SUCCESS);
+        if (RT_FAILURE(rc))
+            break;
+
+        RTTESTI_CHECK_RC(rc = RTDirCreateUniqueNumbered(szName, sizeof(szName), 0700, cchDigits, chSep), VINF_SUCCESS);
+        if (RT_FAILURE(rc))
+        {
+            RTTestIFailed("RTDirCreateUniqueNumbered(%s) call #%u -> %Rrc\n", szName, i, rc);
+            break;
+        }
+
+        RTTESTI_CHECK(papszNames[i] = RTStrDup(szName));
+        if (!papszNames[i])
+            break;
+
+        RTTestIPrintf(RTTESTLVL_DEBUG, "%s\n", papszNames[i]);
+    }
+
+    /* Try to create one more, which shouldn't be possible. */
+    if (RT_SUCCESS(rc))
+    {
+        char szName[RTPATH_MAX];
+        RTTESTI_CHECK_RC(rc = RTPathAppend(strcpy(szName, g_szTempPath), sizeof(szName), "RTDirCreateUniqueNumbered"), VINF_SUCCESS);
+        if (RT_SUCCESS(rc))
+            RTTESTI_CHECK_RC(rc = RTDirCreateUniqueNumbered(szName, sizeof(szName), 0700, cchDigits, chSep), VERR_ALREADY_EXISTS);
+    }
+
+    /* cleanup */
+    while (i-- > 0)
+    {
+        RTTESTI_CHECK_RC(RTDirRemove(papszNames[i]), VINF_SUCCESS);
+        RTStrFree(papszNames[i]);
+    }
+    RTMemTmpFree(papszNames);
+}
+
+
+int main()
+{
+    RTTEST hTest;
+    RTEXITCODE rcExit = RTTestInitAndCreate("tstRTDirCreateUniqueNumbered", &hTest);
+    if (rcExit)
+        return rcExit;
+    RTTestBanner(hTest);
+
+    /*
+     * Get the temp directory (this is essential to the testcase).
+     */
+    int rc;
+    RTTESTI_CHECK_RC(rc = RTPathTemp(g_szTempPath, sizeof(g_szTempPath)), VINF_SUCCESS);
+    if (RT_FAILURE(rc))
+        return RTTestSummaryAndDestroy(hTest);
+
+    /*
+     * Create some test directories.
+     */
+    tst1(1, 1, 0  );
+    tst1(2, 1, '-');
+    tst1(3, 2, 0  );
+    tst1(4, 2, '-');
+
+    /*
+     * Summary.
+     */
+    return RTTestSummaryAndDestroy(hTest);
+}
+