Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 36589)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 36592)
@@ -967,5 +967,5 @@
                                                          sharedMachine, session().GetConsole(),
                                                          strCategory, QString());
-    pDlg->getFrom();
+    pDlg->loadData();
 
     /* Show VM settings dialog: */
@@ -973,5 +973,5 @@
     {
         /* If dialog was accepted => save changed settings: */
-        pDlg->putBackTo();
+        pDlg->saveData();
         sharedMachine.SaveSettings();
         /* If settings were failed to be saved => show the error: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/VBoxSelectorWnd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/VBoxSelectorWnd.cpp	(revision 36589)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/VBoxSelectorWnd.cpp	(revision 36592)
@@ -596,8 +596,8 @@
 
     UISettingsDialog *dlg = new UISettingsDialogGlobal(this, SettingsDialogType_Offline);
-    dlg->getFrom();
+    dlg->loadData();
 
     if (dlg->exec() == QDialog::Accepted)
-        dlg->putBackTo();
+        dlg->saveData();
 
     delete dlg;
@@ -735,9 +735,9 @@
 
     UISettingsDialog *pDlg = new UISettingsDialogMachine(this, dialogType, machine, console, strCategory, strControl);
-    pDlg->getFrom();
+    pDlg->loadData();
 
     if (pDlg->exec() == QDialog::Accepted)
     {
-        pDlg->putBackTo();
+        pDlg->saveData();
 
         machine.SaveSettings();
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.h	(revision 36589)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.h	(revision 36592)
@@ -49,6 +49,6 @@
 
     /* Save/Load interface: */
-    virtual void getFrom() = 0;
-    virtual void putBackTo() = 0;
+    virtual void loadData() = 0;
+    virtual void saveData() = 0;
 
 protected slots:
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp	(revision 36589)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.cpp	(revision 36592)
@@ -300,5 +300,5 @@
     for (int iPageIndex = GLSettingsPage_General; iPageIndex < GLSettingsPage_MAX; ++iPageIndex)
     {
-        if (isAvailable(iPageIndex))
+        if (isPageAvailable(iPageIndex))
         {
             UISettingsPage *pSettingsPage = 0;
@@ -386,5 +386,5 @@
 }
 
-void UISettingsDialogGlobal::getFrom()
+void UISettingsDialogGlobal::loadData()
 {
     /* Prepare global data: */
@@ -403,5 +403,5 @@
 }
 
-void UISettingsDialogGlobal::putBackTo()
+void UISettingsDialogGlobal::saveData()
 {
     /* Get properties and settings: */
@@ -470,10 +470,10 @@
 }
 
-bool UISettingsDialogGlobal::isAvailable(int id)
+bool UISettingsDialogGlobal::isPageAvailable(int iPageId)
 {
     /* Show the host error message for particular group if present.
      * We don't use the generic cannotLoadGlobalConfig()
      * call here because we want this message to be suppressible: */
-    switch (id)
+    switch (iPageId)
     {
         case GLSettingsPage_USB:
@@ -528,5 +528,5 @@
     for (int iPageIndex = VMSettingsPage_General; iPageIndex < VMSettingsPage_MAX; ++iPageIndex)
     {
-        if (isAvailable(iPageIndex))
+        if (isPageAvailable(iPageIndex))
         {
             UISettingsPage *pSettingsPage = 0;
@@ -681,5 +681,5 @@
 }
 
-void UISettingsDialogMachine::getFrom()
+void UISettingsDialogMachine::loadData()
 {
     /* Prepare machine data: */
@@ -701,5 +701,5 @@
 }
 
-void UISettingsDialogMachine::putBackTo()
+void UISettingsDialogMachine::saveData()
 {
     /* Prepare machine data: */
@@ -981,5 +981,5 @@
 }
 
-bool UISettingsDialogMachine::isAvailable(int id)
+bool UISettingsDialogMachine::isPageAvailable(int iPageId)
 {
     if (m_machine.isNull())
@@ -989,10 +989,10 @@
      * We don't use the generic cannotLoadMachineSettings()
      * call here because we want this message to be suppressible. */
-    switch (id)
+    switch (iPageId)
     {
         case VMSettingsPage_Serial:
         {
             /* Depends on ports availability: */
-            if (!isAvailable(VMSettingsPage_Ports))
+            if (!isPageAvailable(VMSettingsPage_Ports))
                 return false;
             break;
@@ -1001,5 +1001,5 @@
         {
             /* Depends on ports availability: */
-            if (!isAvailable(VMSettingsPage_Ports))
+            if (!isPageAvailable(VMSettingsPage_Ports))
                 return false;
             /* But for now this page is always disabled: */
@@ -1009,5 +1009,5 @@
         {
             /* Depends on ports availability: */
-            if (!isAvailable(VMSettingsPage_Ports))
+            if (!isPageAvailable(VMSettingsPage_Ports))
                 return false;
             /* Get the USB controller object: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.h	(revision 36589)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialogSpecific.h	(revision 36592)
@@ -47,6 +47,6 @@
 protected:
 
-    void getFrom();
-    void putBackTo();
+    void loadData();
+    void saveData();
 
     void retranslateUi();
@@ -56,5 +56,5 @@
 private:
 
-    bool isAvailable(int id);
+    bool isPageAvailable(int iPageId);
 };
 
@@ -88,6 +88,6 @@
 protected:
 
-    void getFrom();
-    void putBackTo();
+    void loadData();
+    void saveData();
 
     void retranslateUi();
@@ -106,5 +106,5 @@
 private:
 
-    bool isAvailable(int id);
+    bool isPageAvailable(int iPageId);
 
     CMachine m_machine;