Index: trunk/src/VBox/Additions/linux/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/linux/Makefile.kmk	(revision 36602)
+++ trunk/src/VBox/Additions/linux/Makefile.kmk	(revision 36603)
@@ -336,30 +336,4 @@
 
 #
-# Install the sources of our (sanity) test kernel module
-#
-INSTALLS += LnxAddTest-src
-LnxAddTest-src_INST    = $(subst $(PATH_TARGET),obj,$(VBOX_LNX_ADD_INST_SHARE_DIR)$(VBOX_LNX_ADD_PACKAGE_NAME))/test/
-LnxAddTest-src_MODE    = a+r,u+w
-LnxAddTest-src_SOURCES = \
-	$(VBOX_REL_LNX_ADD_INST)Makefile.test=>Makefile \
-	$(PATH_BIN)/additions/src/vboxguest/build_in_tmp \
-	$(VBOX_REL_LNX_ADD_INST)test.c
-
-
-#
-# Install the sources of our (sanity) test kernel rendering (DRM) module
-#
-INSTALLS += LnxAddDRM-src
-LnxAddDRM-src_INST    = $(subst $(PATH_TARGET),obj,$(VBOX_LNX_ADD_INST_SHARE_DIR)$(VBOX_LNX_ADD_PACKAGE_NAME))/test_drm/
-LnxAddDRM-src_MODE    = a+r,u+w
-LnxAddDRM-src_SOURCES = \
-	$(VBOX_REL_LNX_INST_SRC)Makefile.include.header \
-	$(VBOX_REL_LNX_INST_SRC)Makefile.include.footer \
-	$(VBOX_REL_LNX_ADD_INST)Makefile.test.drm=>Makefile \
-	$(PATH_BIN)/additions/src/vboxguest/build_in_tmp \
-	$(VBOX_REL_LNX_ADD_INST)test_drm.c
-
-
-#
 # We need our routines.sh and the uninstallation scripts in the staging
 # directory too
Index: trunk/src/VBox/Additions/linux/installer/Makefile.test
===================================================================
--- trunk/src/VBox/Additions/linux/installer/Makefile.test	(revision 36602)
+++ 	(revision )
@@ -1,116 +1,0 @@
-#
-# VirtualBox Guest Additions Module Makefile.
-#
-# (For 2.6.x this file must be 'Makefile'!)
-#
-# Copyright (C) 2006-2010 Oracle Corporation
-#
-# Use only with permission
-#
-
-#
-MODULE = vboxadd_test
-OBJS   = test.o
-
-ifneq ($(MAKECMDGOALS),clean)
-
-# kernel base directory
-ifndef KERN_DIR
- KERN_DIR := /lib/modules/$(shell uname -r)/build
- ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
-  KERN_DIR := /usr/src/linux
-  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
-   $(error Error: unable to find the sources of your current Linux kernel. Specify KERN_DIR=<directory> and run Make again.)
-  endif
-  $(warning Warning: using /usr/src/linux as the source directory of your Linux kernel. If this is not correct, specify KERN_DIR=<directory> and run Make again.)
- endif
-else
- ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
-  $(error Error: KERN_DIR does not point to a directory.)
- endif
-endif
-
-# includes
-ifndef KERN_INCL
- KERN_INCL = $(KERN_DIR)/include
-endif
-ifneq ($(shell if test -d $(KERN_INCL); then echo yes; fi),yes)
- $(error Error: unable to find the include directory for your current Linux kernel. Specify KERN_INCL=<directory> and run Make again.)
-endif
-
-# guess kernel version (24 or 26)
-ifeq ($(shell if grep '"2.4.' $(KERN_INCL)/linux/version.h > /dev/null; then echo yes; fi),yes)
-KERN_VERSION := 24
-else
-KERN_VERSION := 26
-endif
-# KERN_VERSION := $(if $(wildcard $(KERN_DIR)/Rules.make),24,26)
-
-# debug - show guesses.
-ifdef DEBUG
-$(warning dbg: KERN_DIR     = $(KERN_DIR))
-$(warning dbg: KERN_INCL    = $(KERN_INCL))
-$(warning dbg: MODULE_DIR   = $(MODULE_DIR))
-$(warning dbg: KERN_VERSION = $(KERN_VERSION))
-endif
-
-
-#
-# Compiler options
-#
-ifndef INCL
- INCL    := -I$(KERN_INCL) $(addprefix -I, $(EXTRA_INCL))
- ifndef KBUILD_EXTMOD
-  KBUILD_EXTMOD := $(shell pwd)
- endif
- INCL    += $(addprefix -I$(KBUILD_EXTMOD),/ /include /r0drv/linux)
- export INCL
-endif
-KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -D_X86_ -DIN_RT_R0 -DIN_SUP_R0 \
-	    -DVBGL_VBOXGUEST -DVBGL_HGCM -DVBOX_WITH_HGCM
-ifeq ($(BUILD_TYPE),debug)
-KFLAGS   += -DDEBUG
-endif
-
-ifeq ($(KERN_VERSION), 24)
-#
-# 2.4
-#
-
-CFLAGS := -DVBOX_LINUX_2_4 $(INCL) $(KFLAGS) $(KDEBUG)
-MODULE_EXT := o
-
-# 2.4 Module linking
-$(MODULE).o: $(OBJS)
-	$(LD) -o $@ -r $(OBJS)
-
-.PHONY: $(MODULE)
-all: $(MODULE)
-$(MODULE): $(MODULE).o
-
-else
-#
-# 2.6 and later
-#
-
-MODULE_EXT := ko
-
-$(MODULE)-y  := $(OBJS)
-
-# build defs
-EXTRA_CFLAGS += $(INCL) $(KFLAGS) $(KDEBUG)
-
-all: $(MODULE)
-
-obj-m += $(MODULE).o
-
-$(MODULE):
-	$(MAKE) KBUILD_VERBOSE=1 -C $(KERN_DIR) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) modules
-
-endif
-
-endif # eq($(MAKECMDGOALS),clean)
-
-clean:
-	for f in . linux r0drv r0drv/linux; do rm -f $$f/*.o $$f/.*.cmd $$f/.*.flags; done
-	rm -rf .vboxdrv* .tmp_ver* vboxdrv.* Module.symvers Modules.symvers
Index: trunk/src/VBox/Additions/linux/installer/Makefile.test.drm
===================================================================
--- trunk/src/VBox/Additions/linux/installer/Makefile.test.drm	(revision 36602)
+++ 	(revision )
@@ -1,24 +1,0 @@
-#
-# VirtualBox Guest Additions Module Makefile.
-#
-# (For 2.6.x this file must be 'Makefile'!)
-#
-# Copyright (C) 2006-2010 Oracle Corporation
-#
-#
-# Use only with permission
-#
-
-# Linux kbuild sets this to our source directory if we are called from there
-obj ?= $(CURDIR)
-
-include $(obj)/Makefile.include.header
-
-MOD_NAME = vboxadd_test_drm
-MOD_OBJS = test_drm.o
-MOD_INCL = $(addprefix -I$(KBUILD_EXTMOD),/ /include /r0drv/linux)
-MOD_CLEAN = . linux r0drv r0drv/linux
-# These are present in the shared folders Makefile but not the main one.
-# MOD_CFLAGS = -DEXPORT_SYMTAB -DVBGL_VBOXGUEST -DRT_WITH_VBOX
-
-include $(obj)/Makefile.include.footer
Index: trunk/src/VBox/Additions/linux/installer/test.c
===================================================================
--- trunk/src/VBox/Additions/linux/installer/test.c	(revision 36602)
+++ 	(revision )
@@ -1,30 +1,0 @@
-/*
- * VirtualBox Guest Additions installer test module for Linux
- *
- * Copyright (C) 2006-2007 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-#include <linux/init.h>
-#include <linux/module.h>
-
-MODULE_DESCRIPTION("VirtualBox Guest Additions configuration test module");
-MODULE_AUTHOR("Oracle Corporation");
-MODULE_LICENSE("GPL");
-
-static int init(void)
-{
-    return 0;
-}
-
-static void fini(void) {}
-
-module_init(init);
-module_exit(fini);
Index: trunk/src/VBox/Additions/linux/installer/test_drm.c
===================================================================
--- trunk/src/VBox/Additions/linux/installer/test_drm.c	(revision 36602)
+++ 	(revision )
@@ -1,32 +1,0 @@
-/*
- * VirtualBox Guest Additions installer test module for Linux
- *
- * Copyright (C) 2006-2007 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-#include <linux/init.h>
-#include <linux/module.h>
-#include "drm/drmP.h"
-
-
-MODULE_DESCRIPTION("VirtualBox Guest Additions drm test module");
-MODULE_AUTHOR("Oracle Corporation");
-MODULE_LICENSE("GPL");
-
-static int init(void)
-{
-    return 0;
-}
-
-static void fini(void) {}
-
-module_init(init);
-module_exit(fini);
Index: trunk/src/VBox/Additions/linux/installer/vboxadd.sh
===================================================================
--- trunk/src/VBox/Additions/linux/installer/vboxadd.sh	(revision 36602)
+++ trunk/src/VBox/Additions/linux/installer/vboxadd.sh	(revision 36603)
@@ -367,17 +367,10 @@
     test_sane_kernel_dir
 
-    if ! sh /usr/share/$PACKAGE/test/build_in_tmp \
-        --no-print-directory >> $LOG 2>&1; then
-        fail_msg
-        printf "Your system does not seem to be set up to build kernel modules.\nLook at $LOG to find out what went wrong.\nOnce you have corrected it, you can run\n\n  /etc/init.d/vboxadd setup\n\nto build them.\n\n"
-        return 1
-    else
-        if ! sh /usr/share/$PACKAGE/test_drm/build_in_tmp \
-            --no-print-directory >> $LOG 2>&1; then
-            printf "\nYour guest system does not seem to have sufficient OpenGL support to enable\naccelerated 3D effects (this requires Linux 2.6.27 or later in the guest\nsystem).  This Guest Additions feature will be disabled.\n\n"
-            BUILDVBOXVIDEO=""
-        fi
-    fi
     echo
+    if expr `uname -r` '<' '2.6.27' > /dev/null; then
+        echo "Not building the VirtualBox advanced graphics driver as this Linux version is"
+        echo "too old to use it."
+        BUILDVBOXVIDEO=
+    fi
     if [ -n "$BUILDVBOXGUEST" ]; then
         begin "Building the main Guest Additions module"